static const char *RcsId     = "$Header: /home/cvsadm/cvsroot/fermi/servers/a2605/src/A2605Class.cpp,v 1.11 2013-08-23 10:24:44 giulio Exp $";
static const char *TagName   = "$Name: release_28 $";
static const char *HttpServer= "http://www.esrf.fr/computing/cs/tango/tango_doc/ds_doc/";
//+=============================================================================
//
// file :        A2605Class.cpp
//
// description : C++ source for the A2605Class. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the A2605 once per process.
//
// project :     TANGO Device Server
//
// $Author: giulio $
//
// $Revision: 1.11 $
//
// $Log: A2605Class.cpp,v $
// Revision 1.11  2013-08-23 10:24:44  giulio
// Moved to Device4Impl
//
// Revision 1.10  2013-04-16 09:44:23  giulio
// Update rt-buffer api's, removed tango rpath, added DeviceState
//
// Revision 1.9  2012-04-19 09:28:22  giulio
// Added command logging buffer
//
// Revision 1.8  2012-01-02 12:55:29  giulio
// .Changed logic in local+rnm current control, add degauss, updated cycling procedure
//
// Revision 1.7  2011/08/26 12:42:56  giulio
// .Increased difftimeerr timeout from 5 to 7 sec. (two times the default polling time)
//
// Revision 1.6  2011/01/17 13:30:20  giulio
// .Set and save ps mac address
//
// Revision 1.5  2011/01/17 11:12:44  giulio
// .Off managed by thread
//
// Revision 1.4  2010/09/27 12:01:42  giulio
// .Check set/read difference.Fault state when difference above a threshold for a certain amount of time
//
// Revision 1.3  2010/09/20 06:55:57  giulio
// .Added support for non realtime communication protocol
//
// Revision 1.2  2010/08/26 13:11:24  giulio
// Fixed a bug in get_wave api
//
//
// copyleft :   European Synchrotron Radiation Facility
//              BP 220, Grenoble 38043
//              FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================


#include <tango.h>

#include <A2605.h>
#include <A2605Class.h>


//+----------------------------------------------------------------------------
/**
 *	Create A2605Class singleton and return it in a C function for Python usage
 */
//+----------------------------------------------------------------------------
extern "C" {
#ifdef WIN32

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_A2605_class(const char *name) {
		return A2605_ns::A2605Class::init(name);
	}
}


namespace A2605_ns
{
//+----------------------------------------------------------------------------
//
// method : 		GetCmdLogCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCmdLogCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCmdLogCmd::execute(): arrived" << endl;

	Tango::DevLong	argin;
	extract(in_any, argin);

	return insert((static_cast<A2605 *>(device))->get_cmd_log(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		StartDegaussingCmd::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StartDegaussingCmd::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StartDegaussingCmd::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->start_degaussing());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		SaveConfigClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *SaveConfigClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "SaveConfigClass::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->save_config());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetCurrentSetClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCurrentSetClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCurrentSetClass::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<A2605 *>(device))->get_current_set(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		AbortClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *AbortClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "AbortClass::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->abort());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		StartCyclingClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *StartCyclingClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "StartCyclingClass::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->start_cycling());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		WaveStartSwClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *WaveStartSwClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "WaveStartSwClass::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->wave_start_sw());
	return new CORBA::Any();
}


//+----------------------------------------------------------------------------
//
// method : 		OnClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "OnClass::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->on());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		OffClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "OffClass::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->off());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		ResetClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "ResetClass::execute(): arrived" << endl;

	((static_cast<A2605 *>(device))->reset());
	return new CORBA::Any();
}

//+----------------------------------------------------------------------------
//
// method : 		GetCurrentClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetCurrentClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetCurrentClass::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<A2605 *>(device))->get_current(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetVoltageClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetVoltageClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetVoltageClass::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<A2605 *>(device))->get_voltage(argin));
}

//+----------------------------------------------------------------------------
//
// method : 		GetVdcLinkClass::execute()
// 
// description : 	method to trigger the execution of the command.
//                PLEASE DO NOT MODIFY this method core without pogo   
//
// in : - device : The device on which the command must be excuted
//		- in_any : The command input data
//
// returns : The command output data (packed in the Any object)
//
//-----------------------------------------------------------------------------
CORBA::Any *GetVdcLinkClass::execute(Tango::DeviceImpl *device,const CORBA::Any &in_any)
{

	cout2 << "GetVdcLinkClass::execute(): arrived" << endl;

	const Tango::DevVarLongArray	*argin;
	extract(in_any, argin);

	return insert((static_cast<A2605 *>(device))->get_vdc_link(argin));
}


//
//----------------------------------------------------------------
//	Initialize pointer for singleton pattern
//----------------------------------------------------------------
//
A2605Class *A2605Class::_instance = NULL;

//+----------------------------------------------------------------------------
//
// method : 		A2605Class::A2605Class(string &s)
// 
// description : 	constructor for the A2605Class
//
// in : - s : The class name
//
//-----------------------------------------------------------------------------
A2605Class::A2605Class(string &s):DeviceClass(s)
{

	cout2 << "Entering A2605Class constructor" << endl;
	set_default_property();
	get_class_property();
	write_class_property();
	
	cout2 << "Leaving A2605Class constructor" << endl;

}
//+----------------------------------------------------------------------------
//
// method : 		A2605Class::~A2605Class()
// 
// description : 	destructor for the A2605Class
//
//-----------------------------------------------------------------------------
A2605Class::~A2605Class()
{
	_instance = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		A2605Class::instance
// 
// description : 	Create the object if not already done. Otherwise, just
//			return a pointer to the object
//
// in : - name : The class name
//
//-----------------------------------------------------------------------------
A2605Class *A2605Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new A2605Class(s);
		}
		catch (bad_alloc)
		{
			throw;
		}		
	}		
	return _instance;
}

A2605Class *A2605Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}

//+----------------------------------------------------------------------------
//
// method : 		A2605Class::command_factory
// 
// description : 	Create the command object(s) and store them in the 
//			command list
//
//-----------------------------------------------------------------------------
void A2605Class::command_factory()
{
	command_list.push_back(new OnClass("On",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new OffClass("Off",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new ResetClass("Reset",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCurrentClass("GetCurrent",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetVoltageClass("GetVoltage",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetVdcLinkClass("GetVdcLink",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new WaveStartSwClass("WaveStartSw",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StartCyclingClass("StartCycling",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new AbortClass("Abort",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCurrentSetClass("GetCurrentSet",
		Tango::DEVVAR_LONGARRAY, Tango::DEVVAR_DOUBLEARRAY,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new SaveConfigClass("SaveConfig",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new StartDegaussingCmd("StartDegaussing",
		Tango::DEV_VOID, Tango::DEV_VOID,
		"",
		"",
		Tango::OPERATOR));
	command_list.push_back(new GetCmdLogCmd("GetCmdLog",
		Tango::DEV_LONG, Tango::DEVVAR_STRINGARRAY,
		"number of last commands",
		"report",
		Tango::OPERATOR));

	//	add polling if any
	for (unsigned int i=0 ; i<command_list.size(); i++)
	{
	}
}

//+----------------------------------------------------------------------------
//
// method : 		A2605Class::get_class_property
// 
// description : 	Get the class property for specified name.
//
// in :		string	name : The property name
//
//+----------------------------------------------------------------------------
Tango::DbDatum A2605Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		A2605Class::get_default_device_property()
// 
// description : 	Return the default value for device property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum A2605Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//+----------------------------------------------------------------------------
//
// method : 		A2605Class::get_default_class_property()
// 
// description : 	Return the default value for class property.
//
//-----------------------------------------------------------------------------
Tango::DbDatum A2605Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}
//+----------------------------------------------------------------------------
//
// method : 		A2605Class::device_factory
// 
// description : 	Create the device object(s) and store them in the 
//			device list
//
// in :		Tango::DevVarStringArray *devlist_ptr : The device name list
//
//-----------------------------------------------------------------------------
void A2605Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{

	//	Create all devices.(Automatic code generation)
	//-------------------------------------------------------------
	for (unsigned long i=0 ; i < devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
						
		// Create devices and add it into the device list
		//----------------------------------------------------
		device_list.push_back(new A2605(this, (*devlist_ptr)[i]));							 

		// Export device to the outside world
		// Check before if database used.
		//---------------------------------------------
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(device_list.back());
		else
			export_device(device_list.back(), (*devlist_ptr)[i]);
	}
	//	End of Automatic code generation
	//-------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//	Method: A2605Class::attribute_factory(vector<Tango::Attr *> &att_list)
//-----------------------------------------------------------------------------
void A2605Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	//	Attribute : Current
	CurrentAttrib	*current = new CurrentAttrib();
	Tango::UserDefaultAttrProp	current_prop;
	current_prop.set_unit("A");
	current_prop.set_standard_unit("1");
	current_prop.set_display_unit("A");
	current_prop.set_format("%.4f");
	current_prop.set_max_value("5");
	current_prop.set_min_value("-5");
	current_prop.set_description("Power supply reading current");
	current->set_default_properties(current_prop);
	att_list.push_back(current);

	//	Attribute : CurrentFb
	CurrentFbAttrib	*current_fb = new CurrentFbAttrib();
	Tango::UserDefaultAttrProp	current_fb_prop;
	current_fb_prop.set_unit("A");
	current_fb_prop.set_standard_unit("1");
	current_fb_prop.set_display_unit("A");
	current_fb_prop.set_format("%.4f");
	current_fb_prop.set_max_value("5");
	current_fb_prop.set_min_value("-5");
	current_fb_prop.set_description("Feedback current setpoint");
	current_fb->set_default_properties(current_fb_prop);
	att_list.push_back(current_fb);

	//	Attribute : VdcLink
	VdcLinkAttrib	*vdc_link = new VdcLinkAttrib();
	Tango::UserDefaultAttrProp	vdc_link_prop;
	vdc_link_prop.set_unit("V");
	vdc_link_prop.set_standard_unit("1");
	vdc_link_prop.set_display_unit("V");
	vdc_link_prop.set_format("%.1f");
	vdc_link_prop.set_max_value("100");
	vdc_link_prop.set_min_value("0");
	vdc_link_prop.set_description("Power supply dc link voltage");
	vdc_link->set_default_properties(vdc_link_prop);
	att_list.push_back(vdc_link);

	//	Attribute : Voltage
	VoltageAttrib	*voltage = new VoltageAttrib();
	Tango::UserDefaultAttrProp	voltage_prop;
	voltage_prop.set_unit("V");
	voltage_prop.set_standard_unit("1");
	voltage_prop.set_display_unit("V");
	voltage_prop.set_format("%.2f");
	voltage_prop.set_max_value("300");
	voltage_prop.set_min_value("-300");
	voltage_prop.set_description("Power supply voltage");
	voltage->set_default_properties(voltage_prop);
	att_list.push_back(voltage);

	//	Attribute : WaveAbsCurMode
	WaveAbsCurModeAttrib	*wave_abs_cur_mode = new WaveAbsCurModeAttrib();
	Tango::UserDefaultAttrProp	wave_abs_cur_mode_prop;
	wave_abs_cur_mode_prop.set_description("If false, waveform current value is summed to the dc value, otherwise current value is equal to the waveform one.");
	wave_abs_cur_mode->set_default_properties(wave_abs_cur_mode_prop);
	att_list.push_back(wave_abs_cur_mode);

	//	Attribute : WaveBunchNumEnd
	WaveBunchNumEndAttrib	*wave_bunch_num_end = new WaveBunchNumEndAttrib();
	Tango::UserDefaultAttrProp	wave_bunch_num_end_prop;
	wave_bunch_num_end_prop.set_format("%d");
	wave_bunch_num_end_prop.set_max_value("2000000000");
	wave_bunch_num_end_prop.set_min_value("0");
	wave_bunch_num_end_prop.set_description("Bunch number that stop the waveform generation");
	wave_bunch_num_end->set_default_properties(wave_bunch_num_end_prop);
	att_list.push_back(wave_bunch_num_end);

	//	Attribute : WaveBunchNumStart
	WaveBunchNumStartAttrib	*wave_bunch_num_start = new WaveBunchNumStartAttrib();
	Tango::UserDefaultAttrProp	wave_bunch_num_start_prop;
	wave_bunch_num_start_prop.set_format("%d");
	wave_bunch_num_start_prop.set_max_value("2000000000");
	wave_bunch_num_start_prop.set_min_value("0");
	wave_bunch_num_start_prop.set_description("Bunch number that trigger the waveform to start");
	wave_bunch_num_start->set_default_properties(wave_bunch_num_start_prop);
	att_list.push_back(wave_bunch_num_start);

	//	Attribute : WaveCycles
	WaveCyclesAttrib	*wave_cycles = new WaveCyclesAttrib();
	Tango::UserDefaultAttrProp	wave_cycles_prop;
	wave_cycles_prop.set_format("%d");
	wave_cycles_prop.set_max_value("1000000");
	wave_cycles_prop.set_min_value("0");
	wave_cycles_prop.set_description("Number of cycles a waveform has to perform if WaveLoopMode is false.");
	wave_cycles->set_default_properties(wave_cycles_prop);
	att_list.push_back(wave_cycles);

	//	Attribute : WaveLoopMode
	WaveLoopModeAttrib	*wave_loop_mode = new WaveLoopModeAttrib();
	Tango::UserDefaultAttrProp	wave_loop_mode_prop;
	wave_loop_mode_prop.set_description("If true, when waveform starts it runs indefinitely, else it runs WaveCycles times.");
	wave_loop_mode->set_default_properties(wave_loop_mode_prop);
	att_list.push_back(wave_loop_mode);

	//	Attribute : WaveStepFactor
	WaveStepFactorAttrib	*wave_step_factor = new WaveStepFactorAttrib();
	Tango::UserDefaultAttrProp	wave_step_factor_prop;
	wave_step_factor_prop.set_description("Waveform changes its value each wavestepfactor clock times.\nThe clock period is the bunch number period or the recovery (10Hz) period when bunch number is not running.\nDefault value is 1.");
	wave_step_factor->set_default_properties(wave_step_factor_prop);
	att_list.push_back(wave_step_factor);

	//	Attribute : WaveTrigBunchNum
	WaveTrigBunchNumAttrib	*wave_trig_bunch_num = new WaveTrigBunchNumAttrib();
	Tango::UserDefaultAttrProp	wave_trig_bunch_num_prop;
	wave_trig_bunch_num_prop.set_description("Enable waveform trigger by bunch number change");
	wave_trig_bunch_num->set_default_properties(wave_trig_bunch_num_prop);
	att_list.push_back(wave_trig_bunch_num);

	//	Attribute : WaveTrigIrq
	WaveTrigIrqAttrib	*wave_trig_irq = new WaveTrigIrqAttrib();
	Tango::UserDefaultAttrProp	wave_trig_irq_prop;
	wave_trig_irq_prop.set_description("Enable waveform trigger by irq ");
	wave_trig_irq->set_default_properties(wave_trig_irq_prop);
	att_list.push_back(wave_trig_irq);

	//	Attribute : WaveTrigSw
	WaveTrigSwAttrib	*wave_trig_sw = new WaveTrigSwAttrib();
	Tango::UserDefaultAttrProp	wave_trig_sw_prop;
	wave_trig_sw_prop.set_description("Enable waveform sw trigger");
	wave_trig_sw->set_default_properties(wave_trig_sw_prop);
	att_list.push_back(wave_trig_sw);

	//	Attribute : CurrentControl
	CurrentControlAttrib	*current_control = new CurrentControlAttrib();
	Tango::UserDefaultAttrProp	current_control_prop;
	current_control_prop.set_format("%d");
	current_control_prop.set_max_value("2");
	current_control_prop.set_min_value("0");
	current_control_prop.set_description("0=local current control\n1=feedback current control\n2=hybrid current control (local+feedback)");
	current_control->set_default_properties(current_control_prop);
	att_list.push_back(current_control);

	//	Attribute : BunchNumber
	BunchNumberAttrib	*bunch_number = new BunchNumberAttrib();
	Tango::UserDefaultAttrProp	bunch_number_prop;
	bunch_number_prop.set_format("%d");
	bunch_number->set_default_properties(bunch_number_prop);
	att_list.push_back(bunch_number);

	//	Attribute : CurrentSet
	CurrentSetAttrib	*current_set = new CurrentSetAttrib();
	Tango::UserDefaultAttrProp	current_set_prop;
	current_set_prop.set_unit("A");
	current_set_prop.set_standard_unit("1");
	current_set_prop.set_display_unit("A");
	current_set_prop.set_format("%.4f");
	current_set_prop.set_max_value("5");
	current_set_prop.set_min_value("-5");
	current_set_prop.set_description("Power supply setpoint current");
	current_set->set_default_properties(current_set_prop);
	att_list.push_back(current_set);

	//	Attribute : CommFrequency
	CommFrequencyAttrib	*comm_frequency = new CommFrequencyAttrib();
	Tango::UserDefaultAttrProp	comm_frequency_prop;
	comm_frequency_prop.set_unit("Hz");
	comm_frequency_prop.set_standard_unit("1");
	comm_frequency_prop.set_display_unit("Hz");
	comm_frequency_prop.set_format("%.2f");
	comm_frequency_prop.set_max_value("100");
	comm_frequency_prop.set_min_value("0");
	comm_frequency_prop.set_description("Coomunication frequency over ethernet");
	comm_frequency->set_default_properties(comm_frequency_prop);
	att_list.push_back(comm_frequency);

	//	Attribute : PsMacAddress
	PsMacAddressAttrib	*ps_mac_address = new PsMacAddressAttrib();
	att_list.push_back(ps_mac_address);

	//	Attribute : DeviceState
	DeviceStateAttrib	*device_state = new DeviceStateAttrib();
	Tango::UserDefaultAttrProp	device_state_prop;
	device_state_prop.set_format("%d");
	device_state_prop.set_max_value("99");
	device_state_prop.set_min_value("0");
	device_state->set_default_properties(device_state_prop);
	device_state->set_memorized();
	device_state->set_memorized_init(true);
	att_list.push_back(device_state);

	//	Attribute : PsStat
	PsStatAttrib	*ps_stat = new PsStatAttrib();
	Tango::UserDefaultAttrProp	ps_stat_prop;
	ps_stat_prop.set_description("bool[0]:  true=power on; false=power off\nbool[1]:  true=generic fault\nbool[2]:  true=dc undervoltage\nbool[3]:  true=mosfet overtemperature\nbool[4]:  true=shunt overtemperature\nbool[5]:  true=external interlock\nbool[6]:  true=input overcurrent\nbool[7]:  true=crowbar (short circuit protection enabled)\nbool[8]:  true=rt comm mode enabled\nbool[9]:  true=communication timeout\nbool[10]: true=bunch number misalignment/timeout\nbool[11]: true=current local control\nbool[12]: true=current feedback (rnm) control\nbool[13]: true=start waveform on bunch number\nbool[14]: true=start waveform on sw trigger\nbool[15]: true=start waveform on interrupt\nbool[16]: true=cycling infinite number of waveforms\nbool[17]: true=waveform running\nbool[18]: true=waveform added to DC vaule; false=waveform pilots directly the ps\nbool[19]: true=ps enabled to communicate\nbool[20]: true=bidirectional communication over rnm enabled\nbool[21]: true=recovery mode running (when bunch number error)\nbool[22]: true=bunch number overrun (tx not transmitted but bunch number changed)\nbool[23]: true=rnm error\nbool[24]: true=ps cycling\n");
	ps_stat->set_default_properties(ps_stat_prop);
	att_list.push_back(ps_stat);

	//	Attribute : Waveform
	WaveformAttrib	*waveform = new WaveformAttrib();
	Tango::UserDefaultAttrProp	waveform_prop;
	waveform_prop.set_unit("A");
	waveform_prop.set_standard_unit("1");
	waveform_prop.set_display_unit("A");
	waveform_prop.set_format("%.5f");
	waveform_prop.set_max_value("20");
	waveform_prop.set_min_value("-20");
	waveform_prop.set_description("Waveform values");
	waveform->set_default_properties(waveform_prop);
	att_list.push_back(waveform);

	//	End of Automatic code generation
	//-------------------------------------------------------------
}

//+----------------------------------------------------------------------------
//
// method : 		A2605Class::get_class_property()
// 
// description : 	Read the class properties from database.
//
//-----------------------------------------------------------------------------
void A2605Class::get_class_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read class properties from database.(Automatic code generation)
	//------------------------------------------------------------------

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_class()->get_property(cl_prop);
	Tango::DbDatum	def_prop;
	int	i = -1;


	//	End of Automatic code generation
	//------------------------------------------------------------------

}

//+----------------------------------------------------------------------------
//
// method : 	A2605Class::set_default_property
// 
// description: Set default property (class and device) for wizard.
//              For each property, add to wizard property name and description
//              If default value has been set, add it to wizard property and
//              store it in a DbDatum.
//
//-----------------------------------------------------------------------------
void A2605Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;

	vector<string>	vect_data;
	//	Set Default Class Properties
	//	Set Default Device Properties
	prop_name = "PsIp";
	prop_desc = "Power supply ip number";
	prop_def  = "10.1.63.6";
	vect_data.clear();
	vect_data.push_back("10.1.63.6");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PsMacAddress";
	prop_desc = "Power supply mac address";
	prop_def  = "00:20:4a:ad:db:5a";
	vect_data.clear();
	vect_data.push_back("00:20:4a:ad:db:5a");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PsUdpPort";
	prop_desc = "Power supply udp port";
	prop_def  = "10001";
	vect_data.clear();
	vect_data.push_back("10001");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CpuUdpPort";
	prop_desc = "Cpu udp port";
	prop_def  = "10011";
	vect_data.clear();
	vect_data.push_back("10011");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PsModel";
	prop_desc = "Power supply model (5/20)";
	prop_def  = "5";
	vect_data.clear();
	vect_data.push_back("5");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "PsIndex";
	prop_desc = "Power supply index";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RnmIndex";
	prop_desc = "Rnm index";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CpuIp";
	prop_desc = "";
	prop_def  = "";
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "SlewRateLimit";
	prop_desc = "If 0 disable slew rate control.";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "CurrentControl";
	prop_desc = "0=local control\n1=feedback (remote) control\n2=local+feedback control";
	prop_def  = "0";
	vect_data.clear();
	vect_data.push_back("0");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "RealtimeControl";
	prop_desc = "Realtime communication";
	prop_def  = "true";
	vect_data.clear();
	vect_data.push_back("true");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DiffTimeErr";
	prop_desc = "If set-read differ for more then DiffTimeErr, then stat in fault";
	prop_def  = "7";
	vect_data.clear();
	vect_data.push_back("7");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "DiffCurrErr";
	prop_desc = "If current differs for more then this current (A), then device in fault.";
	prop_def  = "0.1";
	vect_data.clear();
	vect_data.push_back("0.1");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

	prop_name = "MinDeltaCurRamp";
	prop_desc = "Minimum delta current(set-read) under which ramp is disabled";
	prop_def  = "2";
	vect_data.clear();
	vect_data.push_back("2");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);

}
//+----------------------------------------------------------------------------
//
// method : 		A2605Class::write_class_property
// 
// description : 	Set class description as property in database
//
//-----------------------------------------------------------------------------
void A2605Class::write_class_property()
{
	//	First time, check if database used
	//--------------------------------------------
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("A2605-A2620 Power Supply device server");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("Device server for the A2605 +-5A/20A power supply developed inhouse.");
	description << str_desc;
	data.push_back(description);
		
	//	put cvs location
	string	rcsId(RcsId);
	string	filename(classname);
	start = rcsId.find("/");
	if (start!=string::npos)
	{
		filename += "Class.cpp";
		end   = rcsId.find(filename);
		if (end>start)
		{
			string	strloc = rcsId.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	//	Get CVS tag revision
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	//--------------------------------------------
	get_db_class()->put_property(data);
}

}	// namespace
