//
// file :         a2605offthread.cpp
//
// description :  psa2605 acquisition thread
//
// project :      TANGO Device Server
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//

#include <omnithread.h>
#include "A2605.h"
#include "offthread.h"

namespace A2605_ns
{
/* 
 *	a2605offthread::run()
 *	Run  
 */		
void offthread::run(void *) 
{

	long idx = myacq->psIndex;

	myacq->off_run = true;
	myacq->udp_off_flag = true;

	try {
		if (myacq->psModel == 5) {
			/* switch ps off */
			if (myacq->realtimeControl) {
				a2605_set_onoff(idx, 0, myacq->a2605);
			}
			else {
				myacq->set_udp_onoff(false);
				myacq->attr_Current_write = 0;
			}	
		}	
		else {
			/* set current to 0 */
			if (myacq->realtimeControl)
				a2605_set_current(idx, 0, myacq->a2605);
			else {
				myacq->set_udp_current(0);	
				myacq->attr_Current_write = 0;
			}
			/* wait 2 second */	
			for (int i = 0; i < 20; i++) {
				if (myacq->off_abort)
					break;
				usleep(100000);		
			}
			/* switch ps off */
			if (myacq->realtimeControl) {
				a2605_set_onoff(idx, 0, myacq->a2605);
			}
			else {
				myacq->set_udp_onoff(false);
			}					
		}
	} /* try */
	catch (Tango::DevFailed &e) {}


	myacq->off_run = false;	
	myacq->off_abort = false;	
	myacq->udp_off_flag = false;
	
}





}
